;*************************************************
; -   (20.01.2017)
;   AVR ATMega8
;    
;  0.74 (11.04.2017)
;*************************************************
;  - 4 MHz
.device ATMEGA8

.include "m8def.inc";  

.def	temp 	= r16	;  
.def	temp2	= r17	;  
.def	view 	= r18	; 
.def	rown 	= r19	; 
.def	delay	= r20	;  
.def	vtime	= r21	; 
.def	left	= r22	;  
.def	dleft	= r23	;  
.def	termst	= r24	;   
.def	tslot	= r25	;  / 


.equ	conftim0 = 0b00000010	;  0,  /8 (4/8=500000=2)
.equ	conftim1 = 0b00001011	;  1   ,  /64 (4/64=62500)
.equ	conftim2 = 0b00001111	;  2   ,  /1024 (4/1024=3906,25)
.equ	KTIME	 = 62500		;  (62500/62500=1)
.equ	KDISP	 = 8			;  (3096,25/8=488,28125)


;   
.dseg				;  

;.org 0x60
;korr:	.byte 1

.org 0x61			;  
secu:	.byte 1		;

.org 0x62
min:	.byte 1		;

.org 0x63
hour:	.byte 1		;

.org 0x64
dayn:	.byte 1		; 

.org 0x65
day:	.byte 1		; 

.org 0x66
mon:	.byte 1		;

.org 0x67
year:	.byte 1		;

.org 0x68
tchasi:	.byte 1		;  

.org 0x69
tday:	.byte 1		;  

.org 0x6A
tterm:	.byte 1		;  

.org 0x6B
term0:	.byte 1		;  ( )

.org 0x6C
term0t:	.byte 1		;   ( )

.org 0x6D
term1:	.byte 1		;  ( )

.org 0x6E
term1t:	.byte 1		;   ( )

.org 0x70				;  
disp:.byte 255			;   
_disp:


;  
.cseg					;   
.org 0x00				;    0
	;  
	rjmp init			;   
	reti				;IRQ0 Handler
	reti				;IRQ1 Handler
	rjmp display		;Timer2 Compare Handler
	reti				;Timer2 Overflow Handler
	reti				;Timer1 Capture Handler
	rjmp chasi			;/ 1, ,  
	reti				;/ 1, ,  
	reti				;Timer1 Overflow Handler
	rjmp termometr		;Timer0 Overflow Handler
	reti				;SPI Transfer Complete Handler
	reti				;USART RX Complete Handler
	reti				;UDR Empty Handler
	reti				;USART TX Complete Handler
	reti				;ADC Conversion Complete Handler
	reti				;EEPROM Ready Handler
	reti				;Analog Comparator Handler
	reti				;Two-wire Serial Interface Handler
	reti				;Store Program Memory Ready Handler


; 
init:
	; 
	ldi temp,high(RAMEND);   
	out SPH,temp		 ;    
	ldi temp,low(RAMEND)
	out SPL,temp

	;  /
	ldi temp,0b11110001
	out DDRB, temp		;PB1..PB3 - 
	ldi temp,0b00001110
	out PORTB, temp		;PB1..PB3 = 1

	ser	temp
	out DDRC,temp		;   C - 

	cbi DDRC,5			;PC5 - 
	sbi PORTC,5			;PC5 = 1

	out DDRD,temp		;   D - 

	;  
	ldi temp,conftim0	;    temp
	out TCCR0,temp		;   	

	rcall korr_read_eeprom
	ldi temp2,low(KTIME)	;   
	sub temp2,temp			;  

	;  
	ldi temp,conftim1	;    temp
	out TCCR1B,temp		;   	
	ldi temp,high(KTIME);   
	out OCR1AH,temp		;     	
	;ldi temp,low(KTIME)	;   
	out OCR1AL,temp2		;     	

	;  
	ldi temp,conftim2	;    temp
	out TCCR2,temp		;   
	ldi temp,KDISP		;  
	out OCR2,temp		;   	
		
	;  
	ldi temp,0b10010001	;    1,  2,  0
	out TIMSK,temp		; 

	; 
	ldi temp,0b10000000	; 
	out ACSR, temp

	; 
	clr view
	;clr secu
	clr left
	clr dleft
	clr termst
	ldi tslot,1
	ldi XL,low(secu)	;   X  
	ldi XH,high(secu)
	ldi temp,0
	st X+,temp			; 
	st X+,temp			; 
	st X+,temp			; 
	ldi temp2,1
	st X+,temp2			;  
	st X+,temp2			; 
	st X+,temp2			; 
	st X+,temp			; 
	ldi vtime,5
	st X+,vtime
	st X+,vtime
	st X,vtime

	sei					;  

	;rcall termometr;!!! !!!
	
	;rcall korr_write_eeprom;!!! !!!

;  
main:
	;rcall chasi;!!! !!!
 	rjmp main


; 
chasi:
	ldi XL,low(secu)	;   X  
	ldi XH,high(secu)
	ld temp,X			; secu
	inc temp			;+1
	st X,temp
	cpi temp,60
	brlo chasi_1		; secu < 60, 

	rcall next_min

	ld temp,X			; 
	cpi temp,0
	brne chasi_1		;  0

	rcall next_hour

	ld temp,X			; 
	cpi temp,0
	brne chasi_1		;  0

	rcall kalendar

chasi_1:
	cpi view,10
	breq _chasi

	rcall next_view

_chasi:
	reti


; 
kalendar:
	rcall next_dayn

	rcall next_day

	ld temp,X			; 
	cpi temp,1
	brne kalendar_1

	rcall next_mon

	ld temp,X			; 
	cpi temp,1
	brne kalendar_1

	rcall next_year

kalendar_1:
	ret


;      
display:
	rcall read_pins		;   

	ldi XL,low(disp)	;   X   
	ldi XH,high(disp)

	rcall left_display

	ldi temp2,0b00001111;  . PE1..4=1
	out PORTC,temp2
	
	lsl rown			;  

	sbi	PORTB,0			;  . !EQ=1 ( )

	brne display_1		;    (rown != 0)
	ldi rown,0b00000001

display_1:				;       
	ser temp
	out	PORTD,temp		;PORTD=0b11111111

	ld temp,X+
	and temp,rown		;     rown
	cpse temp,rown		;  ,   =1 (temp == rown)
	cbi	PORTD,0			;PD0 = 0

	ld temp,X+
	and temp,rown
	cpse temp,rown
	cbi	PORTD,1
	
	ld temp,X+
	and temp,rown
	cpse temp,rown
	cbi	PORTD,2
	
	ld temp,X+
	and temp,rown
	cpse temp,rown
	cbi	PORTD,3
	
	ld temp,X+
	and temp,rown
	cpse temp,rown
	cbi	PORTD,4
	
	ld temp,X+
	and temp,rown
	cpse temp,rown
	cbi	PORTD,5
	
	ld temp,X+
	and temp,rown
	cpse temp,rown
	cbi	PORTD,6
	
	ld temp,X+
	and temp,rown
	cpse temp,rown
	cbi	PORTD,7

	lsr temp2
	out PORTC,temp2
	
	brne display_1		; temp2 != 0

;!!!!!!
;    0>1>2>5>4>3>6>7
; 3  5   
	mov temp,rown		;.   PNP 
	com temp			;.   PNP 
	out	PORTD,temp		;   
	cbi	PORTB,0			;  . !EQ=0 ( )

	reti


;  
left_display:
	cpi view,10
	brne _left_display ;view != 10

	ld temp,X+			; -  
	cp left,temp
	breq left_display_2	;left == temp

	inc dleft
	cpi dleft,32
	brne left_display_1	;dleft != 4
	clr dleft
	inc left

left_display_1:
	add XL,left			; 
	brcc _left_display
	inc XH

	ret

left_display_2:
	clr left
	ser view

	rcall next_view

_left_display:
	ret


;    
chasi_to_disp:
	ldi YL,low(disp)		;   Y  
	ldi YH,high(disp)

	ldi XL,low(hour)		;   X  
	ldi XH,high(hour)
	ld temp2,X				;   

	rcall convert_10
	rcall char_to_disp		;  

	mov temp,temp2
	rcall char_to_disp		;  

	ldi temp,255
	st Y+,temp

	ldi temp,10
	rcall char_to_disp		; 

	ldi temp,255
	st Y+,temp

	ld temp2,-X				;   

	rcall convert_10
	rcall char_to_disp		;  

	mov temp,temp2
	rcall char_to_disp		;  

	ldi temp,255
	st Y+,temp

	ldi temp,10		
	rcall char_to_disp		; 

	ldi temp,255
	st Y+,temp

	ld temp2,-X				;   

	rcall convert_10		
	rcall char_to_disp		;  

	mov temp,temp2
	rcall char_to_disp		;  

	ret


;    
day_to_disp:
	ldi YL,low(disp)		;   Y  
	ldi YH,high(disp)

	ldi temp,4
	rcall nul_to_disp

	ldi XL,low(dayn)		;   X  
	ldi XH,high(dayn)
	ld temp,X+				; dayn

	cpi temp,1				;()
	brne day_to_disp_1
	
	ldi temp,32
	rcall char_to_disp

	ldi temp,30
	rcall char_to_disp

day_to_disp_1:
	cpi temp,2				;()
	brne day_to_disp_2
	
	ldi temp,19
	rcall char_to_disp

	ldi temp,35
	rcall char_to_disp

day_to_disp_2:
	cpi temp,3				;()
	brne day_to_disp_3
	
	ldi temp,34
	rcall char_to_disp

	ldi temp,33
	rcall char_to_disp

day_to_disp_3:
	cpi temp,4				;()
	brne day_to_disp_4
	
	ldi temp,40
	rcall char_to_disp

	ldi temp,35
	rcall char_to_disp

day_to_disp_4:
	cpi temp,5				;()
	brne day_to_disp_5
	
	ldi temp,32
	rcall char_to_disp

	ldi temp,35
	rcall char_to_disp

day_to_disp_5:
	cpi temp,6				;()
	brne day_to_disp_6
	
	ldi temp,34
	rcall char_to_disp

	ldi temp,18
	rcall char_to_disp

day_to_disp_6:
	cpi temp,7				;()
	brne day_to_disp_7
	
	ldi temp,19
	rcall char_to_disp

	ldi temp,34
	rcall char_to_disp

day_to_disp_7:
	ldi temp,11
	rcall char_to_disp

	ld temp2,X				; day

	rcall convert_10	
	rcall char_to_disp		; 
		
	mov temp,temp2
	rcall char_to_disp		; 

	ldi temp,4
	rcall nul_to_disp

	ret


;    
termometr_to_disp:
	ldi temp,0b10010001		;    2,  1,  0
	out TIMSK,temp

	ldi YL,low(disp)		;   Y  
	ldi YH,high(disp)

	ldi XL,low(term1)		;   X  
	ldi XH,high(term1)
	ld temp2,X				;  

	ldi XL,low(term0)		;   X  
	ldi XH,high(term0)
	ld temp,X				;  

	;   
	sbrs temp2,7			; ..    =1
	rjmp termometr_to_disp_2
	neg temp2

	;   
	cpi temp,0
	breq termometr_to_disp_1; temp == 0

	subi temp,10
	neg temp
	st X,temp
	dec temp2

termometr_to_disp_1:
	ldi temp,11				;  ""
	rcall char_to_disp

termometr_to_disp_2:
	;    -99..99
	ldi temp,22
	cpi temp2,100
	brsh termometr_to_disp_3

;termometr_to_disp_21:
	rcall convert_10	
	rcall char_to_disp		; 
		
	mov temp,temp2
	rcall char_to_disp		; 

	;   
	ld temp,X				;  
	cpi temp,0
	breq termometr_to_disp_4; temp == 0

	ldi temp,15				;  ""
	rcall char_to_disp

	ld temp,X				;  

termometr_to_disp_3:
	rcall char_to_disp		; 

termometr_to_disp_4:
	ldi temp,2
	rcall nul_to_disp

	ldi temp,34
	rcall char_to_disp

	ldi temp,13
	rcall char_to_disp

	ldi temp,10
	rcall nul_to_disp

	ret


;      
year_to_disp:
	ldi YL,low(disp)		;   Y  
	ldi YH,high(disp)

	ldi temp,2

	rcall char_to_disp		; 2

	ldi temp,0

	rcall char_to_disp		; 0

	ldi XL,low(year)		;   X  
	ldi XH,high(year)
	ld temp2,X				; year

	rcall convert_10
			
	rcall char_to_disp		; 
		
	mov temp,temp2

	rcall char_to_disp		; 

	ldi temp,11

	rcall char_to_disp		;
	
	ld temp2,-X				; mon

	rcall convert_10
			
	rcall char_to_disp		; 
			
	mov temp,temp2

	rcall char_to_disp		; 

	ldi temp,3
	rcall nul_to_disp

	ret


tview_chasi_to_disp:
	ldi YL,low(disp)		;   Y  
	ldi YH,high(disp)

	ldi temp,33
	rcall char_to_disp

	ldi temp,14
	rcall char_to_disp

	ldi temp,40
	rcall char_to_disp

	ldi temp,14
	rcall char_to_disp

	ldi temp,2
	rcall nul_to_disp

	ldi XL,low(tchasi)		;   X  
	ldi XH,high(tchasi)
	ld temp2,X

	rcall convert_10
			
	rcall char_to_disp		; 
		
	mov temp,temp2

	rcall char_to_disp		; 

	ldi temp,34
	rcall char_to_disp

	ldi temp,2
	rcall nul_to_disp

	ret


tview_day_to_disp:
	ldi YL,low(disp)		;   Y  
	ldi YH,high(disp)

	ldi temp,33
	rcall char_to_disp

	ldi temp,14
	rcall char_to_disp

	ldi temp,27
	rcall char_to_disp

	ldi temp,14
	rcall char_to_disp

	ldi temp,2
	rcall nul_to_disp

	ldi XL,low(tday)		;   X  
	ldi XH,high(tday)
	ld temp2,X

	rcall convert_10
	rcall char_to_disp		; 

	mov temp,temp2
	rcall char_to_disp		; 

	ldi temp,34
	rcall char_to_disp
	
	ldi temp,2
	rcall nul_to_disp

	ret


tview_termometr_to_disp:
	ldi YL,low(disp)		;   Y  
	ldi YH,high(disp)

	ldi temp,33
	rcall char_to_disp

	ldi temp,14
	rcall char_to_disp

	ldi temp,35
	rcall char_to_disp

	ldi temp,14
	rcall char_to_disp

	ldi temp,2
	rcall nul_to_disp

	ldi XL,low(tterm)		;   X  
	ldi XH,high(tterm)
	ld temp2,X

	rcall convert_10
	rcall char_to_disp		; 

	mov temp,temp2
	rcall char_to_disp		; 

	ldi temp,34
	rcall char_to_disp

	ldi temp,2
	rcall nul_to_disp

	ret


chasi_korektir_to_disp:
	ldi YL,low(disp)		;   Y  
	ldi YH,high(disp)

	ldi temp,27
	rcall char_to_disp

	ldi temp,14
	rcall char_to_disp

	ldi temp,40
	rcall char_to_disp

	ldi temp,14
	rcall char_to_disp

	ldi temp,2
	rcall nul_to_disp

	ldi temp2,low(KTIME)	;   
	in temp,OCR1AL			;  
	sub temp2,temp

	sbrs temp2,7			; ..   7  ( )
	rjmp chasi_korektir_to_disp_1
	neg temp2

	ldi temp,11
	rcall char_to_disp

chasi_korektir_to_disp_1:
	rcall convert_10
	rcall char_to_disp		; 

	mov temp,temp2
	rcall char_to_disp		; 

	ldi temp,6
	rcall nul_to_disp

	ret


;  
message_to_disp:
	ldi XL,low(day)		;   X  
	ldi XH,high(day)
	ld temp2,X+			; day
	ld temp,X			; mon

	cpi temp,1
	brne message_to_disp_1
	
	cpi temp2,6
	brsh message_to_disp_1

	ldi YL,low(m0101*2)
	ldi YH,high(m0101*2)

	rcall read_text

message_to_disp_1:
	cpi temp,2
	brne message_to_disp_2

	cpi temp2,23
	brne message_to_disp_2

	ldi YL,low(m0223*2)
	ldi YH,high(m0223*2)

	rcall read_text

message_to_disp_2:
	cpi temp,3
	brne message_to_disp_3

	cpi temp2,8
	brne message_to_disp_21

	ldi YL,low(m0308*2)
	ldi YH,high(m0308*2)

	rcall read_text

message_to_disp_21:
	cpi temp2,14
	brne message_to_disp_3

	ldi YL,low(m0314*2)
	ldi YH,high(m0314*2)

	rcall read_text

message_to_disp_3:
	cpi temp,4
	brne message_to_disp_4

	cpi temp2,12
	brne message_to_disp_4

	ldi YL,low(m0412*2)
	ldi YH,high(m0412*2)

	rcall read_text

message_to_disp_4:
	cpi temp,5
	brne message_to_disp_5

	cpi temp2,1
	brne message_to_disp_41

	ldi YL,low(m0501*2)
	ldi YH,high(m0501*2)

	rcall read_text

message_to_disp_41:
	cpi temp2,9
	brne message_to_disp_5

	ldi YL,low(m0509*2)
	ldi YH,high(m0509*2)

	rcall read_text

message_to_disp_5:
	cpi temp,6
	brne message_to_disp_8

	cpi temp2,12
	brne message_to_disp_8

	ldi YL,low(m0612*2)
	ldi YH,high(m0612*2)

	rcall read_text

message_to_disp_8:
	cpi temp,9
	brne message_to_disp_10

	clr r0
	push temp2
	rcall is2902
	pop temp2
	add temp2,r0

	cpi temp2,13
	brne message_to_disp_10

	ldi YL,low(m0913*2)
	ldi YH,high(m0913*2)

	rcall read_text

message_to_disp_10:
	cpi temp,11
	brne message_to_disp_13

	cpi temp2,4
	brne message_to_disp_13

	ldi YL,low(m1104*2)
	ldi YH,high(m1104*2)

	rcall read_text

message_to_disp_13:	
	ret


read_text:
	push ZH
	push ZL

	movw ZL:ZH,YL:YH

	ldi YL,low(disp)	;   Y  
	ldi YH,high(disp)

	lpm temp,Z+
	st Y+,temp			; -     

	ldi temp,30
	rcall nul_to_disp	;   

read_text_1:
	lpm temp,Z+			; 
	cpi temp,255		;  
	breq read_text_2	;temp == 255

	rcall char_to_disp	;   

	rjmp read_text_1
	
read_text_2:
	ldi temp,30
	rcall nul_to_disp	;   

	pop ZL
	pop ZH

	ldi view,10

	ret


;     
;  =temp2
;   =temp,  =temp2
convert_10:
	ser temp
convert_10_1:
	inc temp
	subi temp2,10
	brpl convert_10_1 	; 
	subi temp2,-10

	ret


;    
char_to_disp:
	push ZH
	push ZL

	ldi ZL,low(chars*2)		;   Z  
	ldi ZH,high(chars*2)

	push YH
	push YL
					
char_to_disp_1:
	lpm YL,Z+				;    chars
	lpm YH,Z+
	dec temp
	brpl char_to_disp_1		;temp >= 0

	movw ZH:ZL,YH:YL		;  
	
	pop YL
	pop YH

char_to_disp_2:
	lpm temp,Z+
	st Y+,temp				;    

	cpi temp,255			; 
	brne char_to_disp_2		;   
	
	pop ZL
	pop ZH

	ret


nul_to_disp:
	ldi temp2,255
nul_to_disp_1:
	st Y+,temp2				;
	dec temp
	brpl nul_to_disp_1

	ret


; 
next_view:
	dec vtime
	brpl _next_view

	inc view
	cpi view,3
	brlo next_view_1
	
	clr view

	rcall message_to_disp

	;cpi view,10
	;brne next_view_1
	cpi view,0
	breq next_view_1

	ret

next_view_1:
	ldi XL,low(tchasi)	;   X  
	ldi XH,high(tchasi)
	add XL,view

	ld vtime,X			;  
	rjmp next_view

_next_view:
	rcall set_view

	ret


set_view:
	cpi view,0				; 
	brne set_view_2
	rcall chasi_to_disp

set_view_2:
	cpi view,1				;. 
	brne set_view_3
	rcall day_to_disp

set_view_3:
	cpi view,2				;. 
	brne set_view_4
	rcall termometr_to_disp

set_view_4:
	cpi view,3				;. 
	brne set_view_5
	rcall year_to_disp

set_view_5:
	cpi view,4
	brne set_view_6
	rcall tview_chasi_to_disp

set_view_6:
	cpi view,5
	brne set_view_7
	rcall tview_day_to_disp

set_view_7:
	cpi view,6
	brne set_view_8
	rcall tview_termometr_to_disp

set_view_8:
	cpi view,7
	brne _set_view
	rcall chasi_korektir_to_disp
	ret

_set_view:
	ret


next_min:
	ldi XL,low(secu)	;   X  
	ldi XH,high(secu)
	clr temp
	st X+,temp			; 

	ld temp,X			; 
	inc temp			;+1

	cpi temp,60
	brlo _next_min		;  60, 
	clr temp
_next_min:
	st X,temp			; 

	ret


next_hour:
	ldi XL,low(hour)	;   X  
	ldi XH,high(hour)
	ld temp,X			; 
	inc temp			;+1

	cpi temp,24
	brlo _next_hour		;  24, 
	clr temp
_next_hour:
	st X,temp			; 

	ret


next_dayn:
	ldi XL,low(dayn)	;   X  
	ldi XH,high(dayn)
	ld temp,X			;  
	inc temp			;+1

	cpi temp,8
	brlo next_dayn_1	;  8, 
	ldi temp,1
next_dayn_1:
	st X+,temp			;  

	ret


next_day:
	ldi XL,low(day)		;   X  
	ldi XH,high(day)
	ld temp,X+			; 
	inc temp			; +1
	;st X+,temp			; 
	
	ld temp2,X;			; 

	push ZH
	push ZL

	ldi ZL,low(months*2);   Z  
	ldi ZH,high(months*2)
next_day_1:
	lpm					; -    r0<-Z

	adiw ZH:Zl,1
	dec temp2
	brne next_day_1		;temp2 != 0
	
	ld temp2,X			; 
	cpi temp2,2
	brne next_day_2		; 

	rcall is2902

next_day_2:
	cp r0,temp
	brsh _next_day		;r0 >= temp (   )
	ldi temp,1			; =1
_next_day:
	ldi XL,low(day)		;   X  
	ldi XH,high(day)
	st X,temp			; 
	
	pop ZL
	pop ZH

	ret


; 29 
is2902:
	ldi XL,low(year)	;   X  
	ldi XH,high(year)
	ld temp2,X			; 
is2902_1:
	cpi temp2,0
	breq is2902_2

	subi temp2,4
	brmi _is2902

	rjmp is2902_1

is2902_2:
	inc r0

_is2902:
	ret


next_mon:
	ldi XL,low(mon)		;   X  
	ldi XH,high(mon)
	ld temp,X
	inc temp			; +1

	cpi temp,13
	brlo _next_mon		;  13, 
	ldi temp,1			; =1
_next_mon:
	st X,temp			; 

	ret


next_year:
	ldi XL,low(year)	;   X  
	ldi XH,high(year)
	ld temp,X
	inc temp			; +1

	cpi temp,100
	brlo _next_year		;  100, 
	clr temp			; =0
_next_year:
	st X,temp			; 

	ret


next_tchasi:
	ldi XL,low(tchasi)	;   X  
	ldi XH,high(tchasi)
	ld temp,X

	inc temp
	cpi temp,100
	brlo _next_tchasi	;  100, 
	ldi temp,1
_next_tchasi:
	st X,temp			;

	ret


next_tday:
	ldi XL,low(tday)	;   X  
	ldi XH,high(tday)
	ld temp,X

	inc temp
	cpi temp,100
	brlo _next_tday		;  100, 
	clr temp
_next_tday:
	st X,temp			;

	ret


next_ttermometr:
	ldi XL,low(tterm)		;   X  
	ldi XH,high(tterm)
	ld temp,X

	inc temp
	cpi temp,100
	brlo _next_ttermometr	;  100, 
	clr temp
_next_ttermometr:
	st X,temp				;

	ret


next_chasi_korektir:
	ldi temp,low(KTIME)		;   
	in temp2,OCR1AL			;  
	sub temp,temp2

	inc temp
	cpi temp,36
	brne _next_chasi_korektir; !=36, 
	ldi temp,-35
_next_chasi_korektir:

	;  
	ldi temp2,low(KTIME)	;   
	sub temp2,temp			;  
	;ldi temp,high(KTIME)	;   
	;out OCR1AH,temp		;     	
	out OCR1AL,temp2		;     
	; -   

	ret


;    
korr_read_eeprom:
	;Wait for completion of previous write
	sbic EECR,EEWE
	rjmp korr_read_eeprom
	;Set up address in address (0x00) register
	ldi temp,0
	out  EEARH, temp
	out  EEARL, temp
	;Start eeprom read by writing EERE
	sbi  EECR,EERE
	;Read data from data register
	in  temp,EEDR

	ret


;    
korr_write_eeprom:
	;Wait for completion of previous write
	sbic EECR,EEWE
	rjmp korr_write_eeprom    
	;Set up address (0x00) in address register
	ldi temp,0
	out  EEARH, temp
	out  EEARL, temp

	ldi temp,low(KTIME)	;   
	in temp2,OCR1AL
	sub temp,temp2

	;Write data to data register
	out  EEDR,temp
	;Write logical one to EEMWE
	sbi  EECR,EEMWE
	;Start eeprom write by setting EEWE
	sbi  EECR,EEWE

	ret



;   
read_pins:				
	sbic PINB,3			;      (=0)
	rjmp read_pins_1
	dec delay
	brpl read_pins_4

	inc view			;   
	cpi view,8
	brlo read_pins_0
	clr view
read_pins_0:

	rjmp read_pins_4

read_pins_1:
	sbic PINB,1			;      (=0)
	rjmp read_pins_2
	dec delay
	brpl _read_pins

	cpi view,0
	brne read_pins_11

	rcall next_hour		; 

read_pins_11:
	cpi view,1
	brne read_pins_12

	rcall next_dayn		;  

read_pins_12:
	cpi view,3
	brne read_pins_13
	
	rcall next_year		; 

read_pins_13:
	cpi view,4
	brne read_pins_14
	
	rcall next_tchasi

read_pins_14:
	cpi view,5
	brne read_pins_15
	
	rcall next_tday

read_pins_15:
	cpi view,6
	brne read_pins_16
	
	rcall next_ttermometr

read_pins_16:
	cpi view,7
	brne read_pins_17
	
	rcall next_chasi_korektir

read_pins_17:
	rjmp read_pins_4

read_pins_2:
	sbic PINB,2			;      (=0)
	rjmp read_pins_3
	dec delay
	brpl _read_pins

	cpi view,0
	brne read_pins_21

	rcall next_min		; 

read_pins_21:
	cpi view,1
	brne read_pins_22

	rcall next_day		; 

read_pins_22:
	cpi view,3
	brne read_pins_23
	
	rcall next_mon		; 

read_pins_23:
	cpi view,7
	brne read_pins_24
	
	rcall korr_write_eeprom

read_pins_24:
	rjmp read_pins_4

read_pins_3:
	clr delay
	ret
read_pins_4:
	ldi delay,81
	ldi vtime, 10		;  
	rcall set_view

_read_pins:
	ret


;   
;termst >= 0 - 
;termst >= 1 -   ROM (0xCC)
;termst >= 2 -    (0x44)

;termst >= 3 -  

;termst >= 4 - 
;termst >= 5 -   ROM (0xCC)
;termst >= 6 -   (0xBE)
;termst >= 7 -  
;termst >= 8 -  
;termst >= 9 -  

termometr:
	;  512 
	cpi termst,9
	brne termometr_0

	cpi view,2
	breq termometr_0

	ldi temp,0b10010000	;   -1, -2
	out TIMSK,temp		;   -0

	clr termst			;   

	reti

termometr_0:
	cpi termst,1
	brsh termometr_1
	rcall termometr_reset

	reti

termometr_1:
	cpi termst,2
	brsh termometr_2
	ldi temp,0xCC
	rcall termometr_com

	reti

termometr_2:
	cpi termst,3
	brsh termometr_3
	ldi temp,0x44
	rcall termometr_com

	reti

termometr_3:
	cpi termst,4
	brsh termometr_4

	ldi temp,0b00000101	; /1024 (4/1024=3906,25=256)
	out TCCR0,temp		;   	

	inc tslot
	cpi tslot,25		; 0,000256*256*25=1,6  ( )
	brne _termometr

	inc termst
	ldi temp,0b00000010	; /8 (4/8=500000=2)
	out TCCR0,temp		;   	

	reti

termometr_4:
	cpi termst,5
	brsh termometr_5
	rcall termometr_reset

	reti

termometr_5:
	cpi termst,6
	brsh termometr_6
	ldi temp,0xCC
	rcall termometr_com

	reti

termometr_6:
	cpi termst,7
	brsh termometr_7
	ldi temp,0xBE
	rcall termometr_com

	reti

termometr_7:
	cpi termst,8
	brsh termometr_8
	rcall termometr_data0

	reti

termometr_8:
	cpi termst,9
	brsh _termometr
	rcall termometr_data1

_termometr:
	reti


termometr_reset:
	sbis PINC,5; ..  P5 = 1
	rjmp termometr_reset_1

	sbi DDRC,5		;PC5 - 
	cbi PORTC,5		;PC5 = 0

	clr temp
	out TCNT0,temp	; 

	ret

termometr_reset_1:
	cbi DDRC,5		;PC5 - 
	sbi PORTC,5		;PC5 = 1

	ldi XL,low(term1)	;   X  
	ldi XH,high(term1)

	clr temp
	out TCNT0,temp
termometr_reset_2:
	in temp,TCNT0
	cpi temp,8		; 16 
	brlo termometr_reset_2

termometr_reset_3:
	;   0
	sbis PINC,5		; ..  P5 = 1
	rjmp termometr_reset_4

	in temp,TCNT0
	cpi temp,150		;  300-16 
	brlo termometr_reset_3

	ldi temp,120
	sbrc termst,2		; reset  ..
	subi termst,-2		;...   +2
	st X,temp			;  -   reset

	ldi termst,9		; 

	ret

termometr_reset_4:
	;   1
	sbic PINC,5		; ..  P5 = 0
	rjmp termometr_reset_5

	in temp,TCNT0
	cpi temp,240		;  480-300 
	brlo termometr_reset_4

	ldi temp,121
	sbrc termst,2		; reset  ..
	subi termst,-2		;...   +2
	st X,temp			;  -   reset

	ldi termst,9		; 

	ret

termometr_reset_5:
	inc termst			;   
	ldi tslot,1

	ret


termometr_com:
	and temp,tslot
	cpse temp,tslot		;  ,   =1 (temp == tslot)
	rjmp termometr_com_1

	rcall write1_to_term
	rjmp termometr_com_2

termometr_com_1:
	rcall write0_to_term

termometr_com_2:
	lsl tslot
	brcc _termometr_com

	inc termst
	ldi tslot,1

_termometr_com:
	ret


termometr_data0:

	ldi XL,low(term0t)	;   X  
	ldi XH,high(term0t)
	ld temp,X			;  

	clc					; . 
	rcall read_term

	ror temp			;  

	st X,temp			;   (term0t)

	inc tslot
	cpi tslot,5
	brne _termometr_data0

	swap temp
	andi temp,0b00001111;  4 

	;  () 
	ldi temp2,10
	mul temp,temp2			;r1:r0 = temp*10
	lsr r0
	lsr r0
	lsr r0
	lsr r0
	mov temp,r0

	st -X,temp			;   (term0)
	inc termst
	ldi tslot,1

_termometr_data0:
	ret


termometr_data1:

	ldi XL,low(term1t)	;   X  
	ldi XH,high(term1t)
	ld temp,X			;  

	clc					; . 
	rcall read_term

	ror temp			;  

	st X,temp			;  

	inc tslot
	cpi tslot,9
	brne _termometr_data1

	st -X,temp
	inc termst
	ldi tslot,1

_termometr_data1:
	ret


write0_to_term:
	sbi DDRC,5		;PC5 - 
	cbi PORTC,5		;PC5 = 0

	ldi temp,214	;  84 
	out TCNT0,temp

write0_to_term_1:
	in temp,TCNT0
	cpi temp,252	; 76 
	brlo write0_to_term_1

	cbi DDRC,5		;PC5 - 
	sbi PORTC,5		;PC5 = 1

	ret


write1_to_term:
	sbi DDRC,5		;PC5 - 
	cbi PORTC,5		;PC5 = 0

	ldi temp,214	;  84 
	out TCNT0,temp

write1_to_term_1:
	in temp,TCNT0
	cpi temp,218	; 8 
	brlo write1_to_term_1

	cbi DDRC,5		;PC5 - 
	sbi PORTC,5		;PC5 = 1

	ret


read_term:
	sbi DDRC,5		;PC5 - 
	cbi PORTC,5		;PC5 = 0

	ldi temp2,214	;  84 
	out TCNT0,temp2

read_term_1:
	in temp2,TCNT0
	cpi temp2,218	; 8 
	brlo read_term_1

	cbi DDRC,5		;PC5 - 
	sbi PORTC,5		;PC5 = 1

read_term_2:
	sbis PINC,5		; ..  P5 = 1
	rjmp _read_term

	in temp2,TCNT0
	cpi temp2,252	;  76-8 
	brlo read_term_2
	sec				;  1  . 

_read_term:
	ret


; -  
months:
.db 31,28,31,30,31,30,31,31,30,31,30,31


; 
chars:					
.dw ch0*2, ch1*2, ch2*2, ch3*2, ch4*2, ch5*2, ch6*2, ch7*2, ch8*2, ch9*2
;	0		1		2		3	4		5		6		7	8		9

.dw ch10*2,ch11*2,ch12*2,ch13*2,ch14*2,ch15*2,ch16*2,ch17*2,ch18*2,ch19*2
;	:		-		!	 	.		,	  					
			
.dw ch20*2,ch21*2,ch22*2,ch23*2,ch24*2,ch25*2,ch26*2,ch27*2,ch28*2,ch29*2
;																	

.dw ch30*2,ch31*2,ch32*2,ch33*2,ch34*2,ch35*2,ch36*2,ch37*2,ch38*2,ch39*2
;																	

.dw ch40*2,ch41*2,ch42*2,ch43*2,ch44*2,ch45*2,ch46*2,ch47*2,ch48*2
;								|							


; 
;!!!!!!
;    0>1>2>5>4>3>6>7
; 3  5   
ch0:
.db 0b00000000,0b01111110,0b00000000,255;0

ch1:					
.db 0b01111101,0b00000000,0b01111111,255;1

ch2:
.db 0b00100110,0b01101110,0b01001000,255;2

ch3:
.db 0b01011110,0b01011110,0b00000000,255;3

ch4:
.db 0b11001000,0b11101111,0b00000000,255;4

ch5:
.db 0b01011000,0b01011110,0b00000110,255;5

ch6:
.db 0b00000000,0b01011110,0b00000110,255;6

ch7:
.db 0b11111110,0b11111110,0b00000000,255;7

ch8:
.db 0b00100000,0b01011110,0b00100000,255;8

ch9:
.db 0b01001000,0b01101110,0b00000000,255;9

ch10:
.db 0b10111101,255;

ch11:
.db 0b11011111,0b11011111,0b11011111,255;

ch12:					
.db 0b01000000,255;!

ch13:					
.db 0b11111001,0b11011110,0b11011110,0b11111001,255,255;

ch14:					
.db 0b01111111,255;

ch15:					
.db 0b00111111,255;

ch16:
.db 255,255; 

ch17:					
.db 0b00000001,0b11110110,0b11110110,0b00000001,255,255;

ch18:					
.db 0b00000000,0b01011110,0b01011110,0b10100111,255,255;

ch19:					
.db 0b00000000,0b01011110,0b01011110,0b10100001,255,255;

ch20:					
.db 0b00000000,0b11111110,0b11111110,0b11111110,255,255;

ch21:					
.db 0b00111111,0b10000001,0b10111110,0b10000000,0b00111111,255;

ch22:					
.db 0b00000000,0b01011110,0b01011110,0b01111110,255,255;

ch23:					
.db 0b00100000,0b11011111,0b00000000,0b11011111,0b00100000,255;

ch24:					
.db 0b01111110,0b01011110,0b01011110,0b10100001,255,255;

ch25:					
.db 0b00000000,0b10111111,0b11110111,0b00000000,255,255;

ch26:;!!! !!!
ch27:					
.db 0b00000000,0b11011111,0b11101011,0b00110100,255,255;

ch28:;!!! !!!
ch29:
.db 0b00000000,0b11111101,0b11001011,0b11111101,0b00000000,255;

ch30:					
.db 0b00000000,0b11011111,0b11011111,0b00000000,255,255;

ch31:
.db 0b10000001,0b01111110,0b01111110,0b10000001,255,255;

ch32:					
.db 0b00000000,0b11111110,0b11111110,0b00000000,255,255;

ch33:					
.db 0b00000000,0b11101110,0b11101110,0b11011001,255,255;

ch34:					
.db 0b10000001,0b01111110,0b01111110,0b01111110,255,255;

ch35:					
.db 0b11111110,0b11111110,0b00000000,0b11111110,0b11111110,255;

ch36:
.db 0b01011000,0b01101111,0b01101111,0b10000000,255,255;

ch37:;!!! !!!
ch38:;!!! !!!
ch39:;!!! !!!
ch40:					
.db 0b11011000,0b11101111,0b11101111,0b00000000,255,255;

ch41:;!!! !!!
ch42:
.db 0b10000000,0b10111111,0b10000000,0b10111111,0b10000000,0b00111111,255,255;

ch43:;!!! !!!
ch44:
.db 0b00000000,255;|

ch45:
.db 0b00000000,0b01011111,0b01011111,0b10100111,255,255;
	
ch46:;!!! !!!
ch47:;!!! !!!
ch48:
.db 0b01011001,0b10101110,0b11110110,0b00000000,255,255;


;  
m0101:
.db 98,34,16,16,16,30,31,19,45,44,29,16,16,16,20,31,21,31,29,12,255

m0223:
.db 163,34,16,16,16,21,30,22,29,16,16,16,24,17,42,25,35,30,25,27,17,16,16,16,31,35,22,40,22,34,35,19,17,12,255

m0308:
.db 99,34,16,16,16,21,30,22,29,16,16,16,8,16,16,16,29,17,33,35,17,12,255

m0314:
.db 107,34,16,16,16,21,30,22,29,16,16,16,33,31,23,21,22,30,25,48,12,255

m0412:
.db 127,34,16,16,16,21,30,22,29,16,16,16,27,31,34,29,31,30,17,19,35,25,27,25,12,255

m0501:
.db 130,34,16,16,16,21,30,22,29,16,16,16,19,22,34,30,45,44,16,16,16,25,16,16,16,35,33,36,21,17,12,255

m0509:
.db 98,34,16,16,16,21,30,22,29,16,16,16,32,31,18,22,21,45,44,12,255

m0612:
.db 95,34,16,16,16,21,30,22,29,16,16,16,33,31,34,34,25,25,12,255

m0913:
.db 128,34,16,16,16,21,30,22,29,16,16,16,32,33,31,20,33,17,29,29,25,34,35,17,12,255

m1104:
.db 156,34,16,16,16,21,30,22,29,16,16,16,30,17,33,31,21,30,31,20,31,16,16,16,22,21,25,30,34,35,19,17,12,255
